> For the complete documentation index, see [llms.txt](https://docs.opshub.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.opshub.com/upcoming-release/help-center-index/faqs/tfs-faqs/pipelineserviceconnectionfailure.md).

# How to resolve processing failure for Pipeline integration when there is a Service Connection deleted in the end system?

### Description

When migrating the history of the Pipeline entity, there can be processing failure for the following use case:

* **Use case:** "Service Connection 1" was associated in some steps of any job in the Pipeline entity. The user changed the Service Connection from "Service Connection 1" to "Service Connection 2" and deleted the "Service Connection 1" from the end system.

In the above use case, the following error occurs:\
`OH-TFS/AzureDevOps-0088: Error occurred while executing request : <Request URL>, detailed Server response : {"$id":"1","innerException":null,"message":"The pipeline is not valid. Job <Job>: Step input <Input Name> references service connection <Service Connection ID> which could not be found. The service connection does not exist or has not been authorized for use.<Other Error Data>}"`

### Solution

* If the Service Connection is deleted in the source system, there will be a processing failure in the integration.
* To resolve this failure, the Service Connection ID needs to be replaced with an empty value.
* For this replacement, the following XSLT can be used. In the field mapping, use the below advanced XSLT for the `process` field:

```xml
<process xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:variable name="replaced0" select="SourceXML/updatedFields/Property/process"/>	
  <xsl:variable name="source1" select="'{Service Connection ID}'"/>
  <xsl:variable name="replaced1" select="utils:replace($replaced0,$source1,&#39;&#39;)"/>	
  <xsl:value-of select="$replaced1"/>
</process>
```

* For multiple Service Connections, extend the XSLT as follows:

```xml

<process xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:variable name="replaced0" select="SourceXML/updatedFields/Property/process"/>	
  <xsl:variable name="source1" select="'{Service Connection ID-1}'"/>
  <xsl:variable name="replaced1" select="utils:replace($replaced0,$source1,&#39;&#39;)"/>
  <xsl:variable name="source2" select="'{Service Connection ID-2}'"/>
  <xsl:variable name="replaced2" select="utils:replace($replaced1,$source2,&#39;&#39;)"/>
  <xsl:variable name="source3" select="'{Service Connection ID-3}'"/>
  <xsl:variable name="replaced3" select="utils:replace($replaced2,$source3,&#39;&#39;)"/>
  <xsl:value-of select="$replaced3"/>
</process>
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.opshub.com/upcoming-release/help-center-index/faqs/tfs-faqs/pipelineserviceconnectionfailure.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
